#include <iostream>
#include <conio.h> // MS-DOS & Windows only!
#include <fstream>
#include <filesystem> // C++17 & later!

using namespace std;
using namespace filesystem; // Part of "std".

int i;

bool Repeat()
{
    // This function repeats the program if there are errors in the input or if the program has executed successfully [i.e., if the user wants to run the program again instead of relaunching it manually].

    int tries = 3;
    string answer;

    while(tries != 0 && answer != "N" && answer != "n"){
    cout << "\nWould you like to try again (y/n)? ";
    getline(cin, answer);

    if(answer == "Y" || answer == "y"){
    system("CLS");
    return true;
    } else{
      tries--;
      if(tries >= 2 && answer != "N" && answer != "n"){
      cout << "\nINCORRECT INPUT! You have " << tries << " tries remaining.\n";
      } else if(tries == 1 && answer != "N" && answer != "n"){
        cout << "\nINCORRECT INPUT! You have " << tries << " try remaining.\n";
      } else{
        if(answer != "N" && answer != "n"){
        cout << "\nYou have run out of tries.\n";
        }
        cout << "\nPress any key to continue...";
        getch(); // Waits for a key press to continue.
      }
    }
    }

    return false;
}

void Keygen(int a, int b) // "a" represents the key type [Retail/O97/OEM], whereas "b" represents the amount of keys that will be generated.
{
    // This is the function responsible for generating the keys mentioned below.

    int j, sum;

    srand(time(0)); // Random seed so that the keys are all unique.

    i = 1; // Key counter. "j" is the digit counter.

    ofstream key_file; // Creates object for writing to key files.

    /* ********************RETAIL KEYS [XXX-XXXXXXX]******************** */

    if(a == 1){
    int first_part[3], second_part[7];
    bool same;

    key_file.open("Retail.txt"); // Opens "Retail.txt".

    while(i <= b){
    sum = 0;
    same = false;
    for(j = 0; j <= 2; j++){     // -----
    first_part[j] = rand() % 10; //     | Generates the first three digits.
    }                            // -----
    if((first_part[0] == 3 || first_part[0] == 4 || first_part[0] == 5 || first_part[0] == 6 || first_part[0] == 7 || first_part[0] == 8 || first_part[0] == 9) && (first_part[0] == first_part[1] && first_part[1] == first_part[2])){ // Checks if the first three digits are all equal [Windows 95 does not allow the following: "333", "444", "555", "666", "777", "888" & "999"]. Strangely, "000", "111" & "222" work.
    same = true;
    }
    for(j = 0; j <= 6; j++){             // -----
    if(j != 6){                          //     |
    second_part[j] = rand() % 10;        //     |
    } else{                              //     |    Generates the last seven digits of the key(s) & adds all of its/their digits.
      second_part[j] = (rand() % 7) + 1; //     | The last digit has to be a number between 1 - 7. The rest are numbers between 0 - 9.
    }                                    //     |
    sum = sum + second_part[j];          //     |
    }                                    // -----
    if(sum % 7 == 0 && !same){ // Checks if the sum of the last seven digits is divisible by 7 without a remainder & if the first three digits are not the same. If the aforementioned conditions are met, the function writes a new key to the file.
    for(j = 0; j <= 2; j++){    // -----
    key_file << first_part[j];  //     |
    }                           //     |
    key_file << "-";            //     | Writes the key(s) to the file.
    for(j = 0; j <= 6; j++){    //     |
    key_file << second_part[j]; //     |
    }                           // -----
    if(i != b){       // -----
    key_file << "\n"; //     | Writes a new line after every key except the last one.
    }                 // -----
    i++; // Continues to the next key ["key_amount" >= 2].
    }
    }

    cout << "\nKeys have been saved to \"Retail.txt\" in the program's current directory.\n";
    key_file.close(); // Closes "Retail.txt".

    /* ********************OFFICE 97 KEYS [XXXX-XXXXXXX]******************** */

    } else if(a == 2){
      int four_digits[4], seven_digits[7], algorithm;

      key_file.open("O97.txt"); // Opens "O97.txt".

      while(i <= b){
      sum = 0;
      algorithm = (rand() % 2) + 1; // Determines whether to increase the 4th digit by 1 or 2 [can be either one].
      for(j = 0; j <= 2; j++){      // -----
      four_digits[j] = rand() % 10; //     | Generates the first three digits.
      }                             // -----
      four_digits[3] = four_digits[2] + algorithm; // Makes the 4th digit bigger than the 3rd digit by either 1 or 2. The last digit in the four digit sequence [XXXX] MUST be bigger than the 3rd digit by 1 or 2 in order for the keys to be valid.
      if(four_digits[3] == 10 || four_digits[3] == 11){ // -----
      four_digits[3] = four_digits[3] % 10;             //     | If the value of the 3rd digit is either 10 or 11, the 4th digit becomes 1 or 2, respectively.
      }                                                 // -----
      for(j = 0; j <= 6; j++){              // -----
      if(j != 6){                           //     |
      seven_digits[j] = rand() % 10;        //     |
      } else{                               //     |    Generates the last seven digits of the key(s) & adds all of its/their digits.
        seven_digits[j] = (rand() % 7) + 1; //     | The last digit has to be a number between 1 - 7. The rest are numbers between 0 - 9.
      }                                     //     |
      sum = sum + seven_digits[j];          //     |
      }                                     // -----
      if(sum % 7 == 0){ // Checks if the sum of the last seven digits is divisible by 7 without a remainder.
      for(j = 0; j <= 3; j++){     // -----
      key_file << four_digits[j];  //     |
      }                            //     |
      key_file << "-";             //     | Writes the key(s) to the file.
      for(j = 0; j <= 6; j++){     //     |
      key_file << seven_digits[j]; //     |
      }                            // -----
      if(i != b){       // -----
      key_file << "\n"; //     | Writes a new line after every key except the last one.
      }                 // -----
      i++; // Continues to the next key ["key_amount" >= 2].
      }
      }

      cout << "\nKeys have been saved to \"O97.txt\" in the program's current directory.\n";
      key_file.close(); // Closes "O97.txt".

    /* ********************OEM KEYS [XXXXX-OEM-XXXXXXX-XXXXX]******************** */

    } else{
      int day, year, seven_digits[7], five_digits[5];

      key_file.open("OEM.txt"); // Opens "OEM.txt".

      while(i <= b){
      sum = 0;
      day = (rand() % 366) + 1; // Generates the "day" portion of the first five digits [001 - 366].
      year = (rand() % 8) + 95; // Generates the "year" portion of the first five digits [95 - 02].
      for(j = 0; j <= 6; j++){              // -----
      if(j != 0 && j != 6){                 //     |
      seven_digits[j] = rand() % 10;        //     |
      } else if(j == 0){                    //     |
        seven_digits[j] = 0;                //     | Generates the middle part of the key(s)
      } else{                               //     |     & adds all of its/their digits.
        seven_digits[j] = (rand() % 7) + 1; //     |
      }                                     //     |
      sum = sum + seven_digits[j];          //     |
      }                                     // -----
      for(j = 0; j <= 4; j++){      // -----
      five_digits[j] = rand() % 10; //     | Generates the last five digits of the key(s).
      }                             // -----
      if(sum % 7 == 0){ // Checks if the sum of the middle part of the key is divisible by 7 without a remainder. If the aforementioned condition is met, the function writes a new key to the file.
      if(day >= 1 && day <= 9){          // -----
      key_file << "00" << day;           //     |
      } else if(day >= 10 && day <= 99){ //     |
        key_file << "0" << day;          //     | Puts zeroes in place of the tens & hundreds positions & writes the result to the file.
      } else{                            //     |
        key_file << day;                 //     |
      }                                  // -----
      if(year <= 99){                  // -----
      key_file << year;                //     |
      } else{                          //     | Writes a double-digit year between 1995 - 2002 to the file [e.g., 95 - 1995, 98 - 1998, 02 - 2002...].
        key_file << "0" << year % 100; //     |
      }                                // -----
      key_file << "-OEM-";
      for(j = 0; j <= 6; j++){     // -----
      key_file << seven_digits[j]; //     | Writes the middle part of the key(s) to the file.
      }                            // -----
      key_file << "-";
      for(j = 0; j <= 4; j++){    // -----
      key_file << five_digits[j]; //     | Writes the last five digits of the key(s) to the file.
      }                           // -----
      if(i != b){       // -----
      key_file << "\n"; //     | Writes a new line after every key except the last one.
      }                 // -----
      i++; // Continues to the next key ["key_amount" >= 2].
      }
      }

      cout << "\nKeys have been saved to \"OEM.txt\" in the program's current directory.\n";
      key_file.close(); // Closes "OEM.txt".
    }
}

int main()
{
    do{

    int choice, key_amount, delete_files, view_files, zero = 0, whitespace = 0;
    string string_choice, string_key_amount, string_delete_files, string_view_files, filename, keys;

    /* Early Microsoft products from the 90s used these product key formats:

    1. XXX-XXXXXXX - RETAIL
    2. XXXX-XXXXXXX - OFFICE 97
    3. XXXXX-OEM-XXXXXXX-XXXXX - OEM

    For the retail key, the first three digits [XXX] can be anything from 000 - 999. The other seven digits [XXXXXXX] have to have a sum that is divisible by 7 without a remainder [e.g., 2573155 - 2 + 5 + 7 + 3 + 1 + 5 + 5 = 28; 28 / 7 = 4 - no remainder]. The last digit [Windows 95] cannot be any of the following: 0; >= 8. This does not apply to other Microsoft products [i.e., Office 95, Plus! 95... - Windows 95 keys work on these products & others that use the same format]. Microsoft Office 97 works on the same principle as the retail keys, except for the first four digits [XXXX] - The last digit has to be above the 3rd digit by either 1 or 2. If the 4th digit happens to be >= 10 [i.e., if it happens to be either 10 or 11], then it overflows to either 0 or 1 [i.e., 10 % 10 = 0; 11 % 10 = 1 - it takes the remainder when dividing by 10]. The OEM key is a bit different from the above key formats: The first five digits [XXXXX] represent the date when the OEM key was printed [e.g., 12899 - May 8, 1999]. The first three digits can be any day from 001 - 366 [even if the date would be incorrect, e.g., 36697 - 1997 did not have 366 days]. The next seven digits [XXXXXXX] follow the same rules as the retail key, except that the 1st digit HAS to be 0 [e.g., 0111112]. Finally, the last five digits [XXXXX] can be anything from 00000 to 99999. This keygen is primarily designed for Windows 95, but it should work with other Microsoft products that use the key formats mentioned above [Plus! 95, Plus! 98, Office 95, Early versions of Windows NT...]. */

    cout << "What would you like to do?\n\n";

    cout << "1 = Generate 10-digit [Retail] key(s)       [XXX-XXXXXXX]\n";
    cout << "2 = Generate 11-digit [Office 97] key(s)    [XXXX-XXXXXXX]\n";
    cout << "3 = Generate OEM key(s)                     [XXXXX-OEM-XXXXXXX-XXXXX]\n";
    cout << "=====================================================================\n";
    cout << "4 = View key files\n";
    cout << "5 = Delete key files\n";
    cout << "6 = Exit\n\n";

    cout << "Choice: ";
    getline(cin, string_choice);
    istringstream issc(string_choice);
    issc >> choice;

    if(string_choice[0] == '0' && string_choice.size() >= 2){ // -----
    for(i = 0; i <= string_choice.size() - 1; i++){           //     |
    if(string_choice[0] == string_choice[i]){                 //     |
    zero++;                                                   //     |
    } else{                                                   //     | Checks if there are leading zeroes in the input. If not, it exits out of the loop.
      break;                                                  //     |
    }                                                         //     |
    }                                                         //     |
    }                                                         // -----

    if(!string_choice.empty()){                              // -----
    for(i = 0; i <= string_choice.size() - 1; i++){          //     |
    if(string_choice[i] == ' ' || string_choice[i] == '\t'){ //     |
    whitespace++;                                            //     | Checks if there is whitespace in the input.
    }                                                        //     |
    }                                                        //     |
    }                                                        // -----

    if(issc.eof() == true && choice >= 1 && choice <= 6 && zero == 0 && whitespace == 0 && !string_choice.empty()){ // Checks input validity [continued on lines 395 - 397].
    if(choice >= 1 && choice <= 3){

    cout << "\nHow many keys would you like to generate [1 - 100]? ";
    getline(cin, string_key_amount);
    istringstream isska(string_key_amount);
    isska >> key_amount;

    if(string_key_amount[0] == '0' && string_key_amount.size() >= 2){ // -----
    for(i = 0; i <= string_key_amount.size() - 1; i++){               //     |
    if(string_key_amount[0] == string_key_amount[i]){                 //     |
    zero++;                                                           //     |
    } else{                                                           //     | Checks if there are leading zeroes in the input. If not, it exits out of the loop.
      break;                                                          //     |
    }                                                                 //     |
    }                                                                 //     |
    }                                                                 // -----

    if(!string_key_amount.empty()){                                  // -----
    for(i = 0; i <= string_key_amount.size() - 1; i++){              //     |
    if(string_key_amount[i] == ' ' || string_key_amount[i] == '\t'){ //     |
    whitespace++;                                                    //     | Checks if there is whitespace in the input.
    }                                                                //     |
    }                                                                //     |
    }                                                                // -----

    if(isska.eof() == true && key_amount >= 1 && key_amount <= 100 && zero == 0 && whitespace == 0 && !string_key_amount.empty()){ // -----
    Keygen(choice, key_amount);                                                                                                    //     |
    } else{                                                                                                                        //     | Checks input validity. If the input is valid, the "Keygen" function is executed. Otherwise, the below message is printed to the console & the user is given a choice to repeat the program.
      cout << "\nINCORRECT INPUT!\n";                                                                                              //     |
    }                                                                                                                              // -----

    } else{
      if(choice == 4){

      system("CLS");

      ifstream key_file; // Creates object for reading from key files.

      cout << "Which file would you like to view?\n\n";
      cout << "1 = \"Retail.txt\"\n";
      cout << "2 = \"O97.txt\"\n";
      cout << "3 = \"OEM.txt\"\n\n";

      cout << "Choice: ";
      getline(cin, string_view_files);
      istringstream issvf(string_view_files);
      issvf >> view_files;

      if(string_view_files[0] == '0' && string_view_files.size() >= 2){ // -----
      for(i = 0; i <= string_view_files.size() - 1; i++){               //     |
      if(string_view_files[0] == string_view_files[i]){                 //     |
      zero++;                                                           //     |
      } else{                                                           //     | Checks if there are leading zeroes in the input. If not, it exits out of the loop.
        break;                                                          //     |
      }                                                                 //     |
      }                                                                 //     |
      }                                                                 // -----

      if(!string_view_files.empty()){                                  // -----
      for(i = 0; i <= string_view_files.size() - 1; i++){              //     |
      if(string_view_files[i] == ' ' || string_view_files[i] == '\t'){ //     |
      whitespace++;                                                    //     | Checks if there is whitespace in the input.
      }                                                                //     |
      }                                                                //     |
      }                                                                // -----

      if(issvf.eof() == true && view_files >= 1 && view_files <= 3 && zero == 0 && whitespace == 0 && !string_view_files.empty()){ // Checks input validity [continued on lines 333 - 335].
      if(view_files == 1){        // -----
      filename = "Retail.txt";    //     |
      } else if(view_files == 2){ //     |
        filename = "O97.txt";     //     | Determines which file to view.
        } else{                   //     |
          filename = "OEM.txt";   //     |
          }                       // -----
      if(exists(filename)){           // -----
      key_file.open(filename);        //     |
      cout << "\n";                   //     | Checks if file exists. If so, the file is opened & the appropriate keys are written to it.
      while(getline(key_file, keys)){ //     |            If not, the program reports that the specified file does not exist.
      cout << keys << "\n";           //     |
      }                               // -----
      cout << "\nSize: " << file_size(filename) << " bytes.\n"; // Gets file size (bytes).
      key_file.close(); // Closes file.
      } else{
        cout << "\nFile does not exist.\n";
      }
      } else{
        cout << "\nINCORRECT INPUT!\n";
      }
    } else if(choice == 5){

      system("CLS");

      cout << "Which file would you like to delete?\n\n";
      cout << "1 = \"Retail.txt\"\n";
      cout << "2 = \"O97.txt\"\n";
      cout << "3 = \"OEM.txt\"\n\n";

      cout << "Choice: ";
      getline(cin, string_delete_files);
      istringstream issdf(string_delete_files);
      issdf >> delete_files;

      if(string_delete_files[0] == '0' && string_delete_files.size() >= 2){ // -----
      for(i = 0; i <= string_delete_files.size() - 1; i++){                 //     |
      if(string_delete_files[0] == string_delete_files[i]){                 //     |
      zero++;                                                               //     |
      } else{                                                               //     | Checks if there are leading zeroes in the input. If not, it exits out of the loop.
        break;                                                              //     |
      }                                                                     //     |
      }                                                                     //     |
      }                                                                     // -----

      if(!string_delete_files.empty()){                                    // -----
      for(i = 0; i <= string_delete_files.size() - 1; i++){                //     |
      if(string_delete_files[i] == ' ' || string_delete_files[i] == '\t'){ //     |
      whitespace++;                                                        //     | Checks if there is whitespace in the input.
      }                                                                    //     |
      }                                                                    //     |
      }                                                                    // -----

      if(issdf.eof() == true && delete_files >= 1 && delete_files <= 3 && zero == 0 && whitespace == 0 && !string_delete_files.empty()){ // Checks input validity [continued on lines 385 - 387].
      if(delete_files == 1){        // -----
      filename = "Retail.txt";      //     |
      } else if(delete_files == 2){ //     |
        filename = "O97.txt";       //     | Determines which file to delete.
        } else{                     //     |
          filename = "OEM.txt";     //     |
        }                           // -----
      if(exists(filename)){                              // -----
      if(remove(filename.c_str()) == 0){                 //     |
      cout << "\nFile has been successfully deleted.\n"; //     |
      } else{                                            //     |
        cout << "\nError deleting file!\n";              //     | Checks if file exists. If so, the file is removed (unless there is an error). If not, the program reports that the specified file does not exist. ["remove()" only accepts C strings, not C++ strings, so "c_str()" is used to turn "filename" into a temporary C string].
      }                                                  //     |
      } else{                                            //     |
        cout << "\nFile does not exist.\n";              //     |
      }                                                  // -----
      } else{
        cout << "\nINCORRECT INPUT!\n";
      }
    } else{
      cout << "\nPress any key to continue...";
      getch(); // Waits for a key press to continue.
      return 0;
    }
    }

    } else{
      cout << "\nINCORRECT INPUT!\n";
    }

    } while(Repeat()); // If the "Repeat" function returns "true" [i.e., if the user wants to repeat the program], the program repeats. Otherwise, the program finishes execution.

    /* Written by Lambda

                                          λλλλλλλλλλλλλλλλ
                                    λλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                                λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                             λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                          λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                        λλλλλλλλλλλλλλλλλλ                λλλλλλλλλλλλλλλλλλ
                      λλλλλλλλλλλλλλλ                          λλλλλλλλλλλλλλλ
                    λλλλλλλλλλλλλλ                                λλλλλλλλλλλλλλ
                  λλλλλλλλλλλλλ                                      λλλλλλλλλλλλλ
                 λλλλλλλλλλλλ                                          λλλλλλλλλλλλ
                λλλλλλλλλλλ                                              λλλλλλλλλλλ
              λλλλλλλλλλλ                                                  λλλλλλλλλλλ
             λλλλλλλλλλλ             λλλλλλλλλλλλλ                          λλλλλλλλλλλ
            λλλλλλλλλλ               λλλλλλλλλλλλλ                            λλλλλλλλλλ
            λλλλλλλλλ                λλλλλλλλλλλλλλ                            λλλλλλλλλ
           λλλλλλλλλ                 λλλλλλλλλλλλλλ                             λλλλλλλλλ
          λλλλλλλλλ                         λλλλλλλλ                             λλλλλλλλλ
         λλλλλλλλλ                           λλλλλλλλ                             λλλλλλλλλ
         λλλλλλλλλ                            λλλλλλλ                             λλλλλλλλλ
        λλλλλλλλλ                              λλλλλλλ                             λλλλλλλλλ
        λλλλλλλλ                               λλλλλλλλ                             λλλλλλλλ
        λλλλλλλλ                              λλλλλλλλλ                             λλλλλλλλ
       λλλλλλλλλ                             λλλλλλλλλλλ                            λλλλλλλλλ
       λλλλλλλλ                             λλλλλλλλλλλλ                             λλλλλλλλ
       λλλλλλλλ                            λλλλλλλλλλλλλλ                            λλλλλλλλ
       λλλλλλλλ                           λλλλλλλλλλλλλλλλ                           λλλλλλλλ
       λλλλλλλλ                          λλλλλλλλλλλλλλλλλ                           λλλλλλλλ
       λλλλλλλλ                         λλλλλλλλλλ  λλλλλλλ                          λλλλλλλλ
       λλλλλλλλ                        λλλλλλλλλλ   λλλλλλλ                          λλλλλλλλ
       λλλλλλλλ                       λλλλλλλλλλ     λλλλλλλ                         λλλλλλλλ
       λλλλλλλλ                      λλλλλλλλλλ       λλλλλλλ                        λλλλλλλλ
       λλλλλλλλλ                    λλλλλλλλλλ        λλλλλλλ                       λλλλλλλλλ
        λλλλλλλλ                   λλλλλλλλλλ          λλλλλλλ                      λλλλλλλλ
        λλλλλλλλ                  λλλλλλλλλλ           λλλλλλλλ                     λλλλλλλλ
        λλλλλλλλλ                λλλλλλλλλλ             λλλλλλλ                    λλλλλλλλλ
         λλλλλλλλλ              λλλλλλλλλλ               λλλλλλλ    λλλ           λλλλλλλλλ
          λλλλλλλλ             λλλλλλλλλλ                λλλλλλλλλλλλλλλ          λλλλλλλλ
          λλλλλλλλλ           λλλλλλλλλλ                  λλλλλλλλλλλλλλ         λλλλλλλλλ
           λλλλλλλλλ         λλλλλλλλλλ                   λλλλλλλλλλλλλλλ       λλλλλλλλλ
            λλλλλλλλλ       λλλλλλλλλλ                     λλλλλλλλλλ          λλλλλλλλλ
             λλλλλλλλλ                                      λλλλλ            λλλλλλλλλλ
              λλλλλλλλλλ                                                    λλλλλλλλλλ
                λλλλλλλλλλ                                                λλλλλλλλλλ
                 λλλλλλλλλλλ                                            λλλλλλλλλλλ
                  λλλλλλλλλλλλ                                        λλλλλλλλλλλλ
                    λλλλλλλλλλλλλ                                  λλλλλλλλλλλλλ
                      λλλλλλλλλλλλλλ                            λλλλλλλλλλλλλλ
                        λλλλλλλλλλλλλλλλλ                   λλλλλλλλλλλλλλλλ
                          λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                             λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                                λλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                                    λλλλλλλλλλλλλλλλλλλλλλλλλλλλ
                                           λλλλλλλλλλλλλλλ                                    */

    return 0;
}